## ros-rolling-rmf-traffic 1.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

project(rmf_traffic VERSION 1.4.0)

set(CMAKE_EXPORT_COMPILE_COMMANDS on)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

if(NOT CMAKE_BUILD_TYPE)
  # Use the Release build type by default if the user has not specified one
  set(CMAKE_BUILD_TYPE Release)
endif()

include(GNUInstallDirs)

find_package(fcl 0.6 QUIET)
if(fcl_FOUND)
  message(STATUS "Using installed FCL version: ${FCL_VERSION}")
else()
  message(STATUS "Using in-source FCL")
  add_subdirectory(thirdparty/fcl)
endif()
# TODO(MXG): Remove everything related to maintaining compatibility with 0.5,
# since we are now requiring FCL-0.6+
set(using_new_fcl true)
set(FCL_LIBRARIES fcl)

find_package(rmf_utils REQUIRED)
find_package(eigen3_cmake_module QUIET)
find_package(Eigen3 REQUIRED)
find_package(Threads)

# ===== Traffic control library
file(GLOB_RECURSE core_lib_srcs "src/rmf_traffic/*.cpp")
add_library(rmf_traffic SHARED
  ${core_lib_srcs}
)

find_package(ament_cmake_catch2 QUIET)
find_package(rmf_cmake_uncrustify QUIET)
if(BUILD_TESTING AND ament_cmake_catch2_FOUND AND rmf_cmake_uncrustify_FOUND)
  file(GLOB_RECURSE unit_test_srcs "test/*.cpp")

  ament_add_catch2(
    test_rmf_traffic test/main.cpp ${unit_test_srcs}
    TIMEOUT 300)
  target_link_libraries(test_rmf_traffic
      rmf_traffic
      ${FCL_LIBRARIES}
      Threads::Threads
  )

  if(using_new_fcl)
    target_compile_definitions(test_rmf_traffic PRIVATE RMF_TRAFFIC__USING_FCL_0_6)
  endif()

  target_include_directories(test_rmf_traffic
    PUBLIC
      "${Eigen3_INCLUDE_DIRS}"
    PRIVATE
      $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/>
  )

  find_file(uncrustify_config_file
    NAMES "rmf_code_style.cfg"
    PATHS "${rmf_utils_DIR}/../../../share/rmf_utils/")

  rmf_uncrustify(
    ARGN include src test
    CONFIG_FILE ${uncrustify_config_file}
    MAX_LINE_LENGTH 80
  )
endif()

if(using_new_fcl)
  target_compile_definitions(rmf_traffic PRIVATE RMF_TRAFFIC__USING_FCL_0_6)
endif()

target_link_libraries(rmf_traffic
  PUBLIC
    rmf_utils::rmf_utils
  PRIVATE
    ${FCL_LIBRARIES}
)

target_include_directories(rmf_traffic
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    ${EIGEN3_INCLUDE_DIRS}
)

# Create cmake config files
include(CMakePackageConfigHelpers)

set(INSTALL_CONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/rmf_traffic/cmake")
set(PACKAGE_CONFIG_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/rmf_traffic-config-version.cmake")
set(PACKAGE_CONFIG_FILE "${CMAKE_CURRENT_BINARY_DIR}/rmf_traffic-config.cmake")

configure_package_config_file(
  "${CMAKE_CURRENT_LIST_DIR}/cmake/rmf_traffic-config.cmake.in"
  ${PACKAGE_CONFIG_FILE}
  INSTALL_DESTINATION ${INSTALL_CONFIG_DIR}
)

write_basic_package_version_file(
  ${PACKAGE_CONFIG_VERSION_FILE}
  COMPATIBILITY ExactVersion
)

install(
  TARGETS rmf_traffic
  EXPORT  rmf_traffic-targets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
  DIRECTORY include/rmf_traffic
  DESTINATION include
)

install(
  FILES
    ${PACKAGE_CONFIG_VERSION_FILE}
    ${PACKAGE_CONFIG_FILE}
  DESTINATION ${INSTALL_CONFIG_DIR}
)

install(
  EXPORT rmf_traffic-targets
  FILE rmf_traffic-targets.cmake
  NAMESPACE rmf_traffic::
  DESTINATION ${INSTALL_CONFIG_DIR}
)

export(
  EXPORT rmf_traffic-targets
  FILE ${CMAKE_CURRENT_BINARY_DIR}/rmf_traffic-targets.cmake
  NAMESPACE rmf_traffic::
)

export(PACKAGE rmf_traffic)

=== debian/changelog ===
ros-rolling-rmf-traffic (1.4.1-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Grey <grey@openrobotics.org>  Wed, 27 Oct 2021 10:20:55 -0000

=== debian/control ===
Source: ros-rolling-rmf-traffic
Section: misc
Priority: optional
Maintainer: Grey <grey@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libccd-dev, libeigen3-dev, ros-rolling-ament-cmake-catch2, ros-rolling-eigen3-cmake-module, ros-rolling-rmf-cmake-uncrustify, ros-rolling-rmf-utils, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rmf-traffic
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libccd-dev, libeigen3-dev, ros-rolling-eigen3-cmake-module, ros-rolling-rmf-utils, ros-rolling-ros-workspace
Description: Package for managing traffic in the Robotics Middleware Framework

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rmf-traffic//opt/ros/rolling/lib/:$(CURDIR)/debian/ros-rolling-rmf-traffic//opt/ros/rolling/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-rmf-traffic 3.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
 cmake_minimum_required(VERSION 3.5.0)
 
-project(rmf_traffic VERSION 1.4.0)
+project(rmf_traffic VERSION 3.2.0)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS on)
 
-# Default to C++14
+# Default to C++17
 if(NOT CMAKE_CXX_STANDARD)
   set(CMAKE_CXX_STANDARD 17)
 endif()
@@ -20,7 +20,10 @@
 
 include(GNUInstallDirs)
 
-find_package(fcl 0.6 QUIET)
+# We need to use the internal version of FCL because the upstream version has
+# bugs that are not yet fixed.
+#find_package(fcl 0.6 QUIET)
+
 if(fcl_FOUND)
   message(STATUS "Using installed FCL version: ${FCL_VERSION}")
 else()
@@ -33,9 +36,13 @@
 set(FCL_LIBRARIES fcl)
 
 find_package(rmf_utils REQUIRED)
+find_package(Threads REQUIRED)
+
 find_package(eigen3_cmake_module QUIET)
+if (eigen3_cmake_module_FOUND)
+  set(RMF_TRAFFIC_DEPENDS_EIGEN3_CMAKE_MODULE "find_dependency(eigen3_cmake_module)")
+endif()
 find_package(Eigen3 REQUIRED)
-find_package(Threads)
 
 # ===== Traffic control library
 file(GLOB_RECURSE core_lib_srcs "src/rmf_traffic/*.cpp")
@@ -44,8 +51,8 @@
 )
 
 find_package(ament_cmake_catch2 QUIET)
-find_package(rmf_cmake_uncrustify QUIET)
-if(BUILD_TESTING AND ament_cmake_catch2_FOUND AND rmf_cmake_uncrustify_FOUND)
+find_package(ament_cmake_uncrustify QUIET)
+if(BUILD_TESTING AND ament_cmake_catch2_FOUND AND ament_cmake_uncrustify_FOUND)
   file(GLOB_RECURSE unit_test_srcs "test/*.cpp")
 
   ament_add_catch2(
@@ -72,11 +79,15 @@
     NAMES "rmf_code_style.cfg"
     PATHS "${rmf_utils_DIR}/../../../share/rmf_utils/")
 
-  rmf_uncrustify(
-    ARGN include src test
-    CONFIG_FILE ${uncrustify_config_file}
-    MAX_LINE_LENGTH 80
-  )
+  # Uncrustify is bugging out, giving nonsense false positives for the file
+  # rmf_traffic/src/rmf_traffic/agv/Interpolate.cpp which have no apparent
+  # solution. We will disable uncrustify until this big is fixed or a workaround
+  # can be found.
+#  ament_uncrustify(
+#    ARGN include src test
+#    CONFIG_FILE ${uncrustify_config_file}
+#    MAX_LINE_LENGTH 80
+#  )
 endif()
 
 if(using_new_fcl)
@@ -86,6 +97,7 @@
 target_link_libraries(rmf_traffic
   PUBLIC
     rmf_utils::rmf_utils
+    Threads::Threads
   PRIVATE
     ${FCL_LIBRARIES}
 )
@@ -112,7 +124,7 @@
 
 write_basic_package_version_file(
   ${PACKAGE_CONFIG_VERSION_FILE}
-  COMPATIBILITY ExactVersion
+  COMPATIBILITY SameMajorVersion
 )
 
 install(
@@ -148,4 +160,9 @@
   NAMESPACE rmf_traffic::
 )
 
-export(PACKAGE rmf_traffic)
+# Export ament index path
+file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/ament_index/resource_index/packages/${PROJECT_NAME} "")
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/ament_index/resource_index/packages/${PROJECT_NAME} DESTINATION share/ament_index/resource_index/packages)
+
+file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ament_prefix_path.dsv "prepend-non-duplicate;AMENT_PREFIX_PATH;")
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ament_prefix_path.dsv DESTINATION share/${PROJECT_NAME}/hook)

=== debian/changelog ===
ros-rolling-rmf-traffic (3.2.0-1jammy) jammy; urgency=high



 -- Grey <grey@openrobotics.org>  Wed, 07 Jun 2023 16:00:00 -0000

ros-rolling-rmf-traffic (3.1.0-1jammy) jammy; urgency=high

  * Switch to rst changelogs (#100 <https://github.com/open-rmf/rmf_traffic/pull/100>)
  * Fix multi floor anomaly (#97 <https://github.com/open-rmf/rmf_traffic/pull/97>)
  * Fix end_versions initialization capacity error in ``NegotiatingRouteValidator::Generator::all()`` function (#58 <https://github.com/open-rmf/rmf_traffic/pull/58>)
  * Contributors: 0to1, Grey, Yadunund

 -- Grey <grey@openrobotics.org>  Mon, 05 Jun 2023 16:00:00 -0000

ros-rolling-rmf-traffic (3.0.0-1jammy) jammy; urgency=high

  * Improve robustness of schedule failover: (#88 <https://github.com/open-rmf/rmf_traffic/pull/88>)
  * Allow participant profiles to be changed at runtime: (#87 <https://github.com/open-rmf/rmf_traffic/pull/87>)
  * Fix issues with schedule culling and incremental delays: (#86 <https://github.com/open-rmf/rmf_traffic/pull/86>)
  * Fix dependency_resoution typo: (#82 <https://github.com/open-rmf/rmf_traffic/pull/82>)
  * Quickest path feature: (#84 <https://github.com/open-rmf/rmf_traffic/pull/84>) (#85 <https://github.com/open-rmf/rmf_traffic/pull/85>)
  * More graceful error handling: (#71 <https://github.com/open-rmf/rmf_traffic/pull/71>) (#76 <https://github.com/open-rmf/rmf_traffic/pull/76>) (#80 <https://github.com/open-rmf/rmf_traffic/pull/80>) (#81 <https://github.com/open-rmf/rmf_traffic/pull/81>)

 -- Grey <grey@openrobotics.org>  Sun, 02 Oct 2022 16:00:00 -0000

ros-rolling-rmf-traffic (2.0.0-1jammy) jammy; urgency=high

  * Introduce traffic dependency system: (#70 <https://github.com/open-rmf/rmf_traffic/pull/70>)

 -- Grey <grey@openrobotics.org>  Thu, 17 Mar 2022 16:00:00 -0000

ros-rolling-rmf-traffic (1.5.0-1jammy) jammy; urgency=high

  * Support lane speed limits: (#44 <https://github.com/open-rmf/rmf_traffic/pull/43>)
  * Fix potential race conditions: (#46 <https://github.com/open-rmf/rmf_traffic/pull/46>)
  * Add features to facilitate robust failover: (#54 <https://github.com/open-rmf/rmf_traffic/pull/54>)
  * Significantly improved performance for very large scale nav graphs: (#53 <https://github.com/open-rmf/rmf_traffic/pull/53>)

 -- Grey <grey@openrobotics.org>  Sun, 13 Feb 2022 16:00:00 -0000

ros-rolling-rmf-traffic (1.4.1-1jammy) jammy; urgency=high

  * Using eigen3_cmake_module to fix RHEL build: (#47 <https://github.com/open-rmf/rmf_traffic/pull/47>)

 -- Grey <grey@openrobotics.org>  Tue, 26 Oct 2021 16:00:00 -0000

ros-rolling-rmf-traffic (1.4.0-1jammy) jammy; urgency=high

  * Mandate use of FCL>=0.6: (#39 <https://github.com/open-rmf/rmf_traffic/pull/39>)
  * Make the stubborn negotiator's strategy more flexible: (#40 <https://github.com/open-rmf/rmf_traffic/pull/40>)
  * Fix participant lifecycles: (#35 <https://github.com/open-rmf/rmf_traffic/pull/35>)

 -- Grey <grey@openrobotics.org>  Tue, 31 Aug 2021 16:00:00 -0000

ros-rolling-rmf-traffic (1.3.0-1jammy) jammy; urgency=high

  * Allow a Database to be forked off of a Mirror: (#17 <https://github.com/open-rmf/rmf_traffic/pull/17>)
  * Separate participant descriptions from schedule patches: (#14 <https://github.com/open-rmf/rmf_traffic/pull/14>)
  * Allow navigation graph lanes to be opened or closed: (#11 <https://github.com/open-rmf/rmf_traffic/pull/11>)
  * Add persistence to Traffic Schedule Participant IDs: (#242 <https://github.com/osrf/rmf_core/pull/242>)
  * Allow a minimum plan finish time to be specified: (#307 <https://github.com/osrf/rmf_core/pull/307>)
  * Check itinerary endpoints when negotiating: (#308 <https://github.com/osrf/rmf_core/pull/308>)

 -- Grey <grey@openrobotics.org>  Thu, 06 May 2021 16:00:00 -0000

ros-rolling-rmf-traffic (1.2.0-1jammy) jammy; urgency=high

  * Improve planner performance scaling for large graphs: (#243 <https://github.com/osrf/rmf_core/pull/243>)
  * Add the blockade system for traffic light management: (#226 <https://github.com/osrf/rmf_core/pull/226>)

 -- Grey <grey@openrobotics.org>  Mon, 04 Jan 2021 16:00:00 -0000

ros-rolling-rmf-traffic (1.1.0-1jammy) jammy; urgency=high

  * Allow a Negotiation Table Viewer to see rejected and forfeited statuses, and to check for a submission: (#140 <https://github.com/osrf/rmf_core/pull/140>)
  * Improve heuristic to account for events: (#159 <https://github.com/osrf/rmf_core/pull/159>)
  * Fix an issue with moving robots between floors: (#163 <https://github.com/osrf/rmf_core/pull/163>)
  * Add a generic waiting event: (#158 <https://github.com/osrf/rmf_core/pull/158>)
  * Fix bug that caused exit events to get skipped sometimes: (#166 <https://github.com/osrf/rmf_core/pull/166>)
  * Bump to C++17 and migrate to std::optional: (#177 <https://github.com/osrf/rmf_core/pull/177>)
  * Contributors: Aaron Chong, Geoffrey Biggs, Grey, Kevin_Skywalker, Yadu, ddengster

 -- Grey <grey@openrobotics.org>  Wed, 23 Sep 2020 16:00:00 -0000

ros-rolling-rmf-traffic (1.0.2-1jammy) jammy; urgency=high

  * Improved definition of "traffic conflict" for vechiles that start too close: (#136 <https://github.com/osrf/rmf_core/pull/136>)

 -- Grey <grey@openrobotics.org>  Sun, 26 Jul 2020 16:00:00 -0000

ros-rolling-rmf-traffic (1.0.1-1jammy) jammy; urgency=high

  * Allow users to specify a callback for interrupting a planner: (#130 <https://github.com/osrf/rmf_core/pull/130>)
  * Allow a Negotiation Table Viewer to know when its Table is defunct: (#130 <https://github.com/osrf/rmf_core/pull/130>)

 -- Grey <grey@openrobotics.org>  Sun, 19 Jul 2020 16:00:00 -0000

ros-rolling-rmf-traffic (1.0.0-1jammy) jammy; urgency=high

  * Provides core rmf_traffic utilities
    
    Trajectory - Describe a motion through 2D space
    
    Route - Describe a path that a robot will follow
    
    Motion - Convert a discrete Trajectory into a continuous function
  * Provides rmf_traffic::schedule utilities for managing traffic schedules
    


=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Grey <grey@openrobotics.org>
-Build-Depends: debhelper (>= 9.0.0), libccd-dev, libeigen3-dev, ros-rolling-ament-cmake-catch2, ros-rolling-eigen3-cmake-module, ros-rolling-rmf-cmake-uncrustify, ros-rolling-rmf-utils, ros-rolling-ros-workspace
+Build-Depends: debhelper (>= 9.0.0), cmake, libccd-dev, libeigen3-dev, ros-rolling-ament-cmake-catch2 <!nocheck>, ros-rolling-ament-cmake-uncrustify <!nocheck>, ros-rolling-eigen3-cmake-module, ros-rolling-rmf-utils, ros-rolling-ros-workspace
 Homepage: 
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -17,12 +17,17 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
 
 # Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
 export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
+
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -31,7 +36,8 @@
 	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
